export declare type Dictionary<T> = {
    [id: string]: T;
};
export declare type UnionDictionary<K extends string, V> = {
    [k in K]: V;
};
export declare type AsInterface<T> = {
    [K in keyof T]: T[K];
};
export declare type Opaque<K, T> = T & {
    __TYPE__: K;
};
export declare type DeepPartial<T> = {
    [P in keyof T]?: T[P] extends Array<infer U> ? Array<DeepPartial<U>> : T[P] extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : DeepPartial<T[P]>;
};
export declare type TDictionaryValues<T> = T extends Dictionary<infer U> ? U : never;
export declare type TPrimitive = string | number | boolean | undefined | null;
export declare type DeepReadonly<T> = T extends TPrimitive ? T : T extends Array<infer U> ? ReadonlyArray<U> : T extends Function ? T : DeepReadonlyObject<T>;
export declare type DeepReadonlyObject<T> = {
    readonly [P in keyof T]: DeepReadonly<T[P]>;
};
export declare type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>;
